﻿Imports Syncfusion.Windows.Forms
Imports Syncfusion.Windows.Forms.Tools
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms

Namespace TreeNavigatorDataBinding
    ''' <summary>
    ''' Form1 class inheriting MetroForm class
    ''' </summary>
    Partial Public Class Form1
        Inherits MetroForm

#Region "Variables"
        ' DataTable
        Private dt As New DataTable("AddressLists")

        'Use a DataSet to manage the data
        Private ds As New DataSet()
#End Region

#Region "Constructor"
        ''' <summary>
        ''' Constructor
        ''' </summary>
        Public Sub New()
            InitializeComponent()
            'Add columns to the DataTable
            dt.Columns.Add("Name", GetType(String))
            dt.Columns.Add("Parent", GetType(String))

            'Add rows to the DataTable (Name of the node, Parent node name)
            dt.Rows.Add(New String() {"ParentItem", "0"})
            dt.Rows.Add(New String() {"Level 1 Child", "ParentItem"})
            dt.Rows.Add(New String() {"Level 2 Child", "Level 1 Child"})
            dt.Rows.Add(New String() {"Level 3 Child", "Level 1 Child"})
            dt.Rows.Add(New String() {"Level 4 Child", "Level 3 Child"})
            dt.Rows.Add(New String() {"Level 5 Child", "Level 3 Child"})

            'Add DataTable to the DataSet
            ds.Tables.Add(dt)
            'Add a relationship
            ds.Relations.Add("TreeParentChild", ds.Tables("AddressLists").Columns("Name"), ds.Tables("AddressLists").Columns("Parent"), False)
        End Sub
#End Region

#Region "Function"
        ''' <summary>
        ''' To Populate TreeNavigator
        ''' </summary>
        Public Sub PopulateTree(ByVal dr As DataRow, ByVal menuItem As TreeMenuItem)
            'To iterate through all the rows in the DataSet
            For Each row As DataRow In dr.GetChildRows("TreeParentChild")
                'Creating a TreeNode for each row
                Dim childItem As New TreeMenuItem() With {.Text = (row("Name").ToString())}
                'Add cChild node to the pNode
                menuItem.Items.Add(childItem)
                'Recursively build the tree
                PopulateTree(row, childItem)
            Next row
        End Sub


#End Region

#Region "Events"

        ''' <summary>
        ''' Button Click event
        ''' </summary>
        Private Sub buttonAdv1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonAdv1.Click
            'Iterate all the rows in the DataSet
            For Each dr As DataRow In ds.Tables("AddressLists").Rows
                If dr("Parent").ToString() = "0" Then
                    'Creates a TreeNode if the parent equals 0
                    Dim root As New TreeMenuItem() With {.Text = (dr("Name").ToString())}
                    TreeNavigator1.Items.Add(root)
                    'Recursively builds the tree
                    PopulateTree(dr, root)

                End If
            Next dr
        End Sub

#End Region

    End Class
End Namespace
